package de.effigenix.application.masterdata.customer;

import de.effigenix.domain.masterdata.customer.Customer;
import de.effigenix.domain.masterdata.customer.CustomerError;
import de.effigenix.domain.masterdata.customer.CustomerId;
import de.effigenix.domain.masterdata.customer.CustomerRepository;
import de.effigenix.shared.common.Result;
import de.effigenix.shared.persistence.UnitOfWork;
import de.effigenix.shared.security.ActorId;

import static de.effigenix.shared.common.Result.*;

public class ActivateCustomer {

    private final CustomerRepository customerRepository;
    private final UnitOfWork unitOfWork;

    public ActivateCustomer(CustomerRepository customerRepository, UnitOfWork unitOfWork) {
        this.customerRepository = customerRepository;
        this.unitOfWork = unitOfWork;
    }

    public Result<CustomerError, Customer> execute(CustomerId customerId, ActorId performedBy) {
        Customer customer;
        switch (customerRepository.findById(customerId)) {
            case Failure(var err) ->
                { return Result.failure(new CustomerError.RepositoryFailure(err.message())); }
            case Success(var opt) -> {
                if (opt.isEmpty()) {
                    return Result.failure(new CustomerError.CustomerNotFound(customerId));
                }
                customer = opt.get();
            }
        }
        customer.activate();

        return unitOfWork.executeAtomically(() -> {
            switch (customerRepository.save(customer)) {
                case Failure(var err) ->
                    { return Result.failure(new CustomerError.RepositoryFailure(err.message())); }
                case Success(var ignored) -> { }
            }
            return Result.success(customer);
        });
    }
}
